// Any key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

// watch this forum for bugs in FF
// http://weblogs.mozillazine.org/asa/archives/007945.html

// cyrillic unicode entities reference:
// http://tlt.its.psu.edu/suggestions/international/bylanguage/cyrchart.html
// javascript unicode handling reference:
// http://www.js-examples.com/javascript/core_js15/ident.php#1009568

var tryUpdatinganykey=true;

var anykeyInitializer = {

	anykeyInitializer : function() {
		this.prefLoader = new anykeyPreferenceLoaderLib.anykeyPreferenceLoaderLib();
		this.isTranslatorOn = false;

		this.initanykey = anykeyInitializer.initanykey;
		this.onContextMenuPopup = anykeyInitializer.onContextMenuPopup;
		this.onContextMenuPopupTB = anykeyInitializer.onContextMenuPopupTB;
		this.setupMenuListeners = anykeyInitializer.setupMenuListeners;
		this.updateanykeyStatusBar = anykeyInitializer.updateanykeyStatusBar;
		this.updateanykeyStatusBarForTranslator = anykeyInitializer.updateanykeyStatusBarForTranslator;
		this.checkForNewanykeyVersion = anykeyInitializer.checkForNewanykeyVersion;
		this.onUpdateResponse = anykeyInitializer.onUpdateResponse;
		this.onUpdateError = anykeyInitializer.onUpdateError;
		this.onLoadNewVersion = anykeyInitializer.onLoadNewVersion;

		this.initanykey();
	},

	onStatusPopup : function() {

		item = document.getElementById("statusmenu-anykey-toggleeditor");
		if (item != null) {
			item.hidden = false;
		}
		item = document.getElementById("statusmenu-anykey-keymapreference");
		if (item != null) {
			item.hidden = false;
		}
	},

	onContextMenuPopup : function() {
		var designMode = gContextMenu.target.parentNode.designMode;
		if (!designMode) {
			designMode = gContextMenu.target.parentNode.parentNode.designMode;
		}
		_iframeDocument = null;
		if (designMode=="on") {
			_iframeDocument = gContextMenu.target;
		}
		gContextMenu.showItem("anykeyMenu", gContextMenu.isTextSelected || gContextMenu.onTextInput || (gContextMenu.inFrame && designMode=="on"));

		item = document.getElementById("contextmenu-anykey-toggleeditor");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}
		item = document.getElementById("contextmenu-anykey-keymapreference");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}
		item = document.getElementById("menu-anykey-toggleeditor");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}
		item = document.getElementById("menu-anykey-keymapreference");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}
	},

	onContextMenuPopupTB : function() {
	},

	initanykey : function()
	{
		this.prefLoader.getApplicationContainerType();
		this.prefLoader.loadStrings();
		this.prefLoader.loadPreferences();
		this.setupMenuListeners();
		this.updateanykeyStatusBar();
		anykey.initializeanykey();
		this.checkForNewanykeyVersion();
		this.updateanykeyStatusBar();
	},

	checkForNewanykeyVersion : function() {
		if (tryUpdatinganykey && this.prefLoader.tryUpdating && this.prefLoader.updateVersionCounter>98) {
			tryUpdatinganykey = false;
			var updateURL = "http://anykey.mozdev.org/anykeyupdate.rdf";
			var request = new XMLHttpRequest();
			request.onload = this.onUpdateResponse;
			request.onerror = this.onUpdateError;
			request.open("GET",updateURL,true);
			request.send(null);
		}
	},

	onUpdateResponse : function(event) {
		var response = event.target;
		if (response.status==200) {
			var rdf = response.responseText;
			var newVersion = anykeyTranslator.parseForText(rdf, "<em:version>", "</em:version>");
			var newVersionURL = anykeyTranslator.parseForText(rdf, "<em:updateLink>", "</em:updateLink>");
			var curVersion = anykeyPreferenceLoaderLib.anykeyVersion;
			var newVersionNum = parseInt(newVersion.replace(/\./g, ""));
			if (newVersionNum!=NaN) {
				var curVersionNum = parseInt(curVersion.replace(/\./g, ""));
				if (newVersionNum > curVersionNum) {

					if (confirm("anykey extension has detected a new version " + newVersion + ", press 'OK' to upgrade")) {
						//var fd = new FileDownloader(newVersionURL, newVersion);//fd.start();
						var updater = new XPIUpdateInstaller(newVersionURL, newVersion);
						updater.initiateUpdate();
					}
				}
			}
		}
	},

	onLoadNewVersion : function(event) {
	},

	onUpdateError : function(event) {
	},

	setupMenuListeners : function() {
		if (this.prefLoader.hostAppId=="FF") {
			var menu = document.getElementById("contentAreaContextMenu");
			if (menu) {
				menu.addEventListener("popupshowing", this.onContextMenuPopup, false);
			}
			if (document.getElementById("menu_EditPopup")){
				document.getElementById("menu_EditPopup").addEventListener("popupshowing", this.onContextMenuPopup, false);
			}
		}	
		if (this.prefLoader.hostAppId=="TB") {
			var menuEdit = document.getElementById("menu_Edit");

			if (menuEdit){
				menuEdit.addEventListener("popupshowing", this.onContextMenuPopupTB, false);

			}
			var menuComp = document.getElementById("msgComposeContext");
			if (menuComp) {
				menuComp.addEventListener("popupshowing", this.onContextMenuPopupTB, false);
			}
			if (document.getElementById("messagePaneContext")){
				document.getElementById("messagePaneContext").addEventListener("popupshowing", this.onContextMenuPopupTB,false);    
			}
			if (document.getElementById("msgComposeContext")){
				document.getElementById("msgComposeContext").addEventListener("popupshowing", this.onContextMenuPopupTB,false);    
			}
		}
	},

	updateanykeyStatusBar : function() {
		var anykeyStatusBarButton = document.getElementById('anykey-status');
		if(anykeyStatusBarButton) {
			if (anykeyPreferenceLoaderLib.showIcon) {
				anykeyStatusBarButton.hidden=false;
				this.isTranslatorOn = TextEditorLibAnyKey.areAnyTextEditorsAttached();
				var anykeyStatusBarButtonTooltip = document.getElementById('anykey-tooltip-value');
				var shortCutsTipStr=" (shortcuts: "+this.prefLoader.shortCutString+")";
				if (this.isTranslatorOn) {
					anykeyStatusBarButton.setAttribute("status", "enabled");
					anykeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.anykeyStrings.getString("statusbar-tooltip-enabled")+shortCutsTipStr);
				} else {
					anykeyStatusBarButton.setAttribute("status", "disabled");
					anykeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.anykeyStrings.getString("statusbar-tooltip-disabled")+shortCutsTipStr);
				}

			} else {
				anykeyStatusBarButton.hidden=true;
			}
		}
	},

	updateanykeyStatusBarForTranslator : function() {
		var anykeyStatusBarButton = document.getElementById('anykey-status');
		if(anykeyStatusBarButton)
		{
			if (anykeyPreferenceLoaderLib.showIcon) {
				anykeyStatusBarButton.hidden=false;
				var anykeyStatusBarButtonTooltip = document.getElementById('anykey-tooltip-value');
				if (anykeyStatusBarButton.getAttribute("status")=="translating1") {
					anykeyStatusBarButton.setAttribute("status", "translating2");
					anykeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.anykeyStrings.getString("statusbar-tooltip-translating"));
				} else {
					anykeyStatusBarButton.setAttribute("status", "translating1");
					anykeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.anykeyStrings.getString("statusbar-tooltip-translating"));
				}
			} else {
				anykeyStatusBarButton.hidden=true;
			}
		}
	}
}