// Any key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

// watch this forum for bugs in FF
// http://weblogs.mozillazine.org/asa/archives/007945.html

// cyrillic unicode entities reference:
// http://tlt.its.psu.edu/suggestions/international/bylanguage/cyrchart.html
// javascript unicode handling reference:
// http://www.js-examples.com/javascript/core_js15/ident.php#1009568


var anykeyInit = null;
// for some unnatural reason trim function is not in ThunderBird.
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };

if (window) {

window.addEventListener(
  "load",
  function () {
    // Add a callback to be run every time a document loads.
    // note that this includes frames/iframes within the document
    gBrowser.addEventListener("load",  function() {anykeyInit = new anykeyInitializer.anykeyInitializer();}, true);
  },
  false
);

}


var anykey = {
	buffer :"",
	initializeanykey : function() {
		TextEditorLibAnyKey.initTextEditorLib();
	},
	initBuffer : function(){
		this.buffer="";
	},
	truncateBuffer : function(){
		if(this.buffer.length>2)
			this.buffer=this.buffer.substring(this.buffer.length-2,this.buffer.length);
	},
	toggleTranslator : function() {
		var result = TextEditorLibAnyKey.toggleEditor(anykey.letter);
		anykeyInit.updateanykeyStatusBar();
	},
	showKeyMapReference : function() {
		var doc = document.commandDispatcher.focusedWindow.document;
		var bodies = doc.getElementsByTagName("body");
		var body = null;
		if (bodies!=null && bodies.length>0) {
			body = bodies[0];
		} else {
			consoleDump("There is no body in this document.");
			return;
		}
		var onPageRefDiv = doc.getElementById("_anykey_keymap_ref_div_id");
		if (onPageRefDiv!=null) {
			var now = new Date();
			onPageRefDiv.id=onPageRefDiv.id + now.getHours() + now.getMinutes() + now.getSeconds();
			onPageRefDiv.style.visibility = "hidden";
		}
		var newDiv = doc.createElement("div");
		newDiv.id="_anykey_keymap_ref_div_id";
		var keymap=anykeyPreferenceLoaderLib.keymap;
		if(keymap==null)
			keymap=anykeyInit.prefLoader.keymap;
		if(keymap==null){
			anykeyInit = new anykeyInitializer.anykeyInitializer();
			keymap=anykeyInit.prefLoader.keymap;
		}
		var keyMapName = anykeyPreferenceLoaderLib.keyMapName;
		if(keyMapName==null)
			keyMapName=anykeyInit.prefLoader.keyMapName;
		var table = doc.createElement("table");
		var row = doc.createElement("tr");
		var col = doc.createElement("td");
		var img = doc.createElement("img");
		img.src="chrome://anykey/locale/move-arrows.jpg";
		img.setAttribute("onmousedown", "_anykey_mouseDown(event);");
		img.alt="Move Reference Window";
		col.appendChild(img);
		row.appendChild(col);
		col = doc.createElement("td");
		var par = doc.createElement("p");
		par.appendChild(doc.createTextNode(keyMapName + " Keyboard Map [key]:[value]"));
		par.style.font="normal 900 14px arial";
		par.style.color="yellow";
		par.id="_anykey_ref_map_name_par_id";
		col.appendChild(par);
		col.align="center";
		row.appendChild(col);
		col = doc.createElement("td");
		img = doc.createElement("img");
		img.src="chrome://anykey/locale/detach-window.jpg";
		img.setAttribute("onclick", "_anykey_detachReferenceDiv(event);");
		img.alt="Detach Reference Window";
		col.appendChild(img);
		img = doc.createElement("img");
		img.src="chrome://anykey/locale/close-window.jpg";
		img.alt="Close Reference Window";
		img.setAttribute("onclick", "_anykey_closeReferenceDiv();");
		var script = doc.createElement("script");
		script.type="text/javascript";
		script.src="chrome://anykey/locale/anykey-ref-jscript.js";
		doc.body.appendChild(script);
		col.appendChild(img);
		col.align="right";
		row.appendChild(col);
		table.appendChild(row);
		newDiv.appendChild(table);
		table.style.width="460px";
		table = doc.createElement("table");
		table.id="_anykey_keymapReferenceTable";
		table.setAttribute("border", "1");
		table.setAttribute("cellpadding", "2px");
		row = doc.createElement("tr");
		var curCol=0;
		var curRow = 0;
		var str = "";
		var keys = keymap.keys();
		for(var k=0;k<keys.length;k++) {
			var key = keys[k];
			str = key + " : " + keymap.get(key);
			col = doc.createElement("td");
			col.appendChild(doc.createTextNode(str));
			row.appendChild(col);
			curCol++;
			if (curCol==10) {
				table.appendChild(row);
				row = doc.createElement("tr");
				curCol=0;
				curRow++;
			} else if (k+1==keys.length) {
				for(var c=curCol;c<10;c++) {
					col = doc.createElement("td");
					col.appendChild(doc.createTextNode(""));
					row.appendChild(col);
				}
				table.appendChild(row);
				curRow++;
			}
		}
		var newScrollDiv = doc.createElement("div");
		newScrollDiv.style.overflow="auto";
		newScrollDiv.appendChild(table);
		newDiv.appendChild(newScrollDiv);
		newDiv.style.position="absolute";
		newDiv.style.left="2px";
		newDiv.style.top="2px";
		newDiv.style.width="460px";
		if (curRow>10) {
			curRow=10;
		}
		newDiv.style.height=(curRow * 10) + "px";
		newDiv.style.color="yellow";
		newDiv.style.backgroundColor="blue";
		table.style.backgroundColor="black";
		table.style.color="yellow";
		table.style.font="normal 900 12px arial";
		table.style.width="460px";
		table.style.height=(curRow * 10) + "px";
		body.appendChild(newDiv);
		newDiv.style.zIndex="10000";
		newDiv.style.visibility="visible";
	},
	translit : function() {
		anykey.truncateBuffer();
		TextEditorLibAnyKey.transformSelectionText(anykey.translateTranslitString, true, false);
	},
	translitSpecialUnicodeChar : function(thelet) {
		switch(thelet) {
			case 8217: return "\u044C";
		}
		return -1;
	},
	letter : function(thelet, isCapital, isShiftOn) {
		var ch=-1;
		var i=0;
		//consoleDump("letter:  "+thelet);
		//consoleDump("anykey.buffer:  "+anykey.buffer);
		var key = anykey.buffer+String.fromCharCode(thelet);
		ch = anykey.getTransformed(key);
		if (ch instanceof Array) {
			for (i=0;i<ch.length;i++){
				if (parseInt(ch[i])==8)
					anykey.buffer=anykey.buffer.substring(0,anykey.buffer.length-1);
				else
					anykey.buffer=anykey.buffer+ch[i];
			}
		} else {
			anykey.buffer=anykey.buffer+ch;
		}
		return ch;
	},
	getTransformed : function(keytoTrans){
		var newBuffer=-1;
		var size=keytoTrans.length;
		var keymap=anykeyPreferenceLoaderLib.keymap;
		if(keymap==null)
			keymap=anykeyInit.prefLoader.keymap;
		if(keymap==null){
			anykeyInit = new anykeyInitializer.anykeyInitializer();
			keymap=anykeyInit.prefLoader.keymap;
		}
		// consoleDump("getTransformed for key:  "+keytoTrans);
		if (size==1) {
			if (keymap.containsKey(keytoTrans)) {
				// consoleDump("keymap contains key:  "+keytoTrans);
				newBuffer=keymap.get(keytoTrans);
			} else {
				newBuffer=keytoTrans;
				anykey.initBuffer();
			}
		} else {
			if(keymap.containsKey(keytoTrans)) {
				// consoleDump("keymap contains key:  "+keytoTrans);
				newBuffer=new Array(size);
				for(i=0;i<size;i++) {
					newBuffer[i]="\8";
				}
				newBuffer[i-1]=keymap.get(keytoTrans);
			} else { //consoleDump("keymap does not contain key:  "+keytoTrans+"call getTransformed with "+keytoTrans.substring(1,keytoTrans.length));
				newBuffer=anykey.getTransformed(keytoTrans.substring(1,keytoTrans.length));
			}
		}
		// consoleDump("getTransformed --> newBuffer:  "+newBuffer);
		return newBuffer;
	},
	translateTranslitString : function(text) {
		var textNew = "";
		var ch;
		anykey.initBuffer();
		for(var i=0;i<text.length;i++) {
			var thelet = text.charCodeAt(i);
			//  consoleDump("to transform: " + thelet);
			ch=anykey.letter(thelet,false,false);
			// consoleDump("transformed: " + ch);
			if (ch instanceof Array) {
				for(var j=0;j<ch.length;j++) {
					if (ch[j]=="\8"){
						textNew=textNew.substring(0,textNew.length-1);
					} else {
						textNew+=ch[j];
					}
				}
			} else {
				textNew+=ch;
			}
		}
		// consoleDump("new text: " + textNew);
		return textNew;
	}
}
