// Any key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

// watch this forum for bugs in FF
// http://weblogs.mozillazine.org/asa/archives/007945.html

// cyrillic unicode entities reference:
// http://tlt.its.psu.edu/suggestions/international/bylanguage/cyrchart.html
// javascript unicode handling reference:
// http://www.js-examples.com/javascript/core_js15/ident.php#1009568

var anykeyPreferenceLoaderLib = {

	extensionInstallVersion : "1.5.4",
	hostAppId : null,
	anykeyVersion : null,
	showIcon : true,

	anykeyPreferenceLoaderLib : function() {
		this.hostAppId=null;
		this.anykeyVersion=null;
		this.tryUpdating=false;
		this.updateVersionCounter=0;

		// forward translator mappings:
		// keymap is for all real upper and lower case characters
		this.keymap;
		this.keyMapName;


		this.shortCutString=null;

		this.anykeyStrings = null;
		this.getUnicodePref = anykeyPreferenceLoaderLib.getUnicodePref;
		this.getPreferenceBranch = anykeyPreferenceLoaderLib.getPreferenceBranch;
		this.getApplicationContainerType = anykeyPreferenceLoaderLib.getApplicationContainerType;

		this.loadPreferredKeyboardMap = anykeyPreferenceLoaderLib.loadPreferredKeyboardMap;
		this.keyMapChanged=anykeyPreferenceLoaderLib.keyMapChanged;
		this.loadPreferredShortcuts = anykeyPreferenceLoaderLib.loadPreferredShortcuts;
		this.setShortcutKey = anykeyPreferenceLoaderLib.setShortcutKey;
		this.loadPreferences = anykeyPreferenceLoaderLib.loadPreferences;
		this.loadStrings = anykeyPreferenceLoaderLib.loadStrings;
		this.loadUpdatePreference = anykeyPreferenceLoaderLib.loadUpdatePreference;
		this.setUpdatePreference = anykeyPreferenceLoaderLib.setUpdatePreference;
		this.loadanykeyVersion = anykeyPreferenceLoaderLib.loadanykeyVersion;
		this.setanykeyVersion = anykeyPreferenceLoaderLib.setanykeyVersion;
		this.getNextUpdateCounterPreference = anykeyPreferenceLoaderLib.getNextUpdateCounterPreference;
		this.loadStatusBarIconPreference = anykeyPreferenceLoaderLib.loadStatusBarIconPreference;
	},



	anykeyPreferenceObserver : {
		prefs : undefined,
	
		register : function(prefsBranch) {
			this.prefs = prefsBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			this.prefs.addObserver("", this, false);
		},
	
		unregister : function() {
			if (this.prefs) {
				this.prefs.removeObserver("", this);
			} else {
				throw "cannot unload preference observer.";
			}
		},
	
		observe : function(aSubject, aTopic, aData) {
			if(aTopic!="nsPref:changed") return;
			//aSubject.QueryInterface(Components.interfaces.nsIPrefBranch);
			if (aData.search(/shortcuts/i) >= 0) {
				anykeyPreferenceLoaderLib.loadPreferredShortcuts(aSubject);
			} else if(aData.search(/KeyboardMap/i) >=0) {
				this.loadPreferredKeyboardMap(aSubject);
			} else if(aData.search(/keyMapName/i) >=0) {
				anykeyPreferenceLoaderLib.loadPreferredKeyboardMap(anykeyPreferenceLoaderLib.getPreferenceBranch());
			}
		}
	},

	getApplicationContainerName : function() {
		var hostAppId;
		// retrieve application id
		//const FIREFOX_ID = "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}";
		//const THUNDERBIRD_ID = "{3550f703-e582-4d05-9a08-453d09bdfdc6}";
		if("@mozilla.org/xre/app-info;1" in Components.classes) {
			// running under Mozilla 1.8 or later
			var id = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).ID;
			if(id == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}") {
				hostAppId = "FF";
			} else if(id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
				hostAppId = "TB";
			} else {
				// another app
			}	
		} else {
			try {
				var id = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getCharPref("app.id");
				if(id == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}") {
					hostAppId = "FF";
				} else if(id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
					hostAppId = "TB";
				} else {
					// another app
				}
			} catch(e) {
				// very old version
				//dump(e);
			}
		}
		return hostAppId;
	},

	getApplicationContainerType : function() {
		var hostAppId = anykeyPreferenceLoaderLib.getApplicationContainerName();
		anykeyPreferenceLoaderLib.hostAppId=hostAppId;
		this.hostAppId=hostAppId;
	},

	getNextUpdateCounterPreference : function(prefBranch) {
		var counter = 0;
		try {
			counter = prefBranch.getIntPref("version.update.counter") + 1;
			if (counter>100) counter = 0;
			prefBranch.setIntPref("version.update.counter", counter);
		} catch(e) {
			counter = 0;
			prefBranch.setIntPref("version.update.counter", counter);
		}
		this.updateVersionCounter = counter;
	},

	loadStatusBarIconPreference : function(prefBranch) {
		var showIcon=true;
		try {
			showIcon = prefBranch.getBoolPref("statusbar.showicon");
		} catch(e) {
			showIcon=true;
			prefBranch.setBoolPref("statusbar.showicon", showIcon);
		}
		anykeyPreferenceLoaderLib.showIcon=showIcon;
	},

	loadUpdatePreference : function(prefBranch) {
		var tryUpdating = false;
		try {
			tryUpdating = prefBranch.getBoolPref("version.autoupdate");
		} catch(e) {
			tryUpdating = true;
			prefBranch.setBoolPref("version.autoupdate", tryUpdating);
		}
		this.tryUpdating = tryUpdating;
	},

	setUpdatePreference : function(prefBranch, tryUpdating) {
		try {
			prefBranch.setBoolPref("version.autoupdate", tryUpdating);
		} catch (e) {
			tryUpdating=true;
			prefBranch.setBoolPref("version.autoupdate", tryUpdating);
		}
		this.tryUpdating = tryUpdating;
	},

	loadanykeyVersion : function(prefBranch) {
		var version;
		try {
			version = prefBranch.getCharPref("version");
		} catch (e) {
			version = anykeyPreferenceLoaderLib.extensionInstallVersion;
			prefBranch.setCharPref("version", version);
		}
		this.anykeyVersion = version;
		anykeyPreferenceLoaderLib.anykeyVersion = version;
	},

	setanykeyVersion : function(prefBranch, version) {
		try {
			prefBranch.setCharPref("version", version);
		} catch (e) {
			version = anykeyPreferenceLoaderLib.extensionInstallVersion;
			prefBranch.setCharPref("version", version);
		}
		this.anykeyVersion = version;
		anykeyPreferenceLoaderLib.anykeyVersion = version;
	},

	loadPreferredShortcuts : function(prefBranch) {
		var prefix;
		if (this.hostAppId == "FF") {
			prefix="ff.";
		} else if (this.hostAppId=="TB") {
			prefix="tb.";
		} else {
			return;
		}
		this.shortCutString="";
		var key;
		try {
			key = prefBranch.getCharPref(prefix + "shortcuts.toggleintexteditor");
		} catch (e) {
			key = "VK_F2";
			prefBranch.setCharPref(prefix + "shortcuts.toggleintexteditor", key);
		}
		anykeyPreferenceLoaderLib.setShortcutKey(key, "key-anykey-toggleeditor");
		this.shortCutString += key;
		try {
			key = prefBranch.getCharPref(prefix + "shortcuts.translit");
		} catch (e) {
			key = "control shift VK_M";
			prefBranch.setCharPref(prefix + "shortcuts.translit", key);
		}
		anykeyPreferenceLoaderLib.setShortcutKey(key, "key-anykey-translit");
		this.shortCutString += " / "+ key;
		try {
			key = prefBranch.getCharPref(prefix + "shortcuts.keymapreference");
		} catch (e) {
			key = "control shift VK_K";
			prefBranch.setCharPref(prefix + "shortcuts.keymapreference", key);
		}
		anykeyPreferenceLoaderLib.setShortcutKey(key, "key-anykey-keymapreference");
		this.shortCutString += " / "+ key;
	},

	setShortcutKey : function(keyString, shortcutStr) {
		keyString = keyString.toLowerCase();
		var found = keyString.match(/(vk_[A-Z0-9]+)/i);
		if (!found) return;
		var keyCode = found[0];
		var mods = "";
		keyString = keyString.replace(/ctrl/i, "control");
		var stdmods = new Array("accel", "alt", "control", "meta", "shift");
		for (var i = 0; i < stdmods.length; i++) {
			if (keyString.indexOf(stdmods[i]) >= 0)
				mods += (mods == "" ? "" : ", ") + stdmods[i];
		}
		var element = document.getElementById(shortcutStr);
		if (element) {
			var key;
			if (keyCode.length == 4) {
				key = keyCode.substr(3);
				element.setAttribute("key", key);
			} else {
				key = keyCode.toUpperCase();
				element.removeAttribute("key");
				element.setAttribute("keycode", key);
			}
			element.setAttribute("modifiers", mods);
		}
	},
	
	getUnicodePref : function (prefName,prefBranch) {
		return prefBranch.getComplexValue(prefName, Components.interfaces.nsISupportsString).data;
	},


	loadKeyMapList :function(){
		var prefBranch= anykeyPreferenceLoaderLib.getPreferenceBranch();
		var keyMapList=prefBranch.getCharPref("KeyboardList");
		var keyMapArray=eval("("+keyMapList+")") ;
		return  keyMapArray;
	},

	loadPreferredKeyboardMap : function(prefBranch) {
		var languageMap;
		var keyMapName;
		try {
			keyMapName=prefBranch.getCharPref("keyMapName");
			languageMap= anykeyPreferenceLoaderLib.getUnicodePref(keyMapName,prefBranch);
		} catch (e) {
			consoleDump("Failed loading keyboard map: " + e);
			// cannot find preference, set default preference.
			keyMapName="amharic-sera";
			languageMap= prefBranch.getComplexValue(keyMapName, Components.interfaces.nsISupportsString).data;
			prefBranch.setCharPref("KeyboardMap", languageMap);
			prefBranch.setCharPref("keyMapName", keyMapName);
		}
		var keymapPairDelimiter = ",";
		var hash=eval("("+languageMap+")") ;
		this.keymap = new Hashtable(hash);
		this.keyMapName = keyMapName;
		//consoleDump("keymap"+this.keymap.toString());
	},



	getPreferenceBranch : function() {
		return Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("anykey.");
	},

	loadPreferences : function() {
		var prefs = this.getPreferenceBranch();
		try {
			this.loadStatusBarIconPreference(prefs);
			this.loadUpdatePreference(prefs);
			this.getNextUpdateCounterPreference(prefs);
			this.loadanykeyVersion(prefs);
			this.loadPreferredShortcuts(prefs);
			this.loadPreferredKeyboardMap(prefs);


		} catch(e) {
			consoleDump(e.message);
		}
		anykeyPreferenceLoaderLib.anykeyPreferenceObserver.register(prefs);
	},

	loadStrings : function() {
		this.anykeyStrings = document.getElementById("anykeyStrings");
		var anykeyLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{60dc76ae-47f1-42e5-997f-7f1ef3d6f3e8}.");
		var anykeylocaledescription = this.anykeyStrings.getString("anykey-description");
	
		var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
		str.data = anykeylocaledescription;
		anykeyLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
	}
}