// Any key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

// watch this forum for bugs in FF
// http://weblogs.mozillazine.org/asa/archives/007945.html

var anykeyPreferencesManager = {

	hostAppId : null,

	load : function() {
		anykeyPreferencesManager.hostAppId = anykeyPreferenceLoaderLib.getApplicationContainerName();

		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("anykey.");
		try {
			anykeyPreferenceLoaderLib.loadPreferredShortcuts(prefs);
			var prefix;
			var savedLabel = document.getElementById("savedLabel");
			if (anykeyPreferencesManager.hostAppId=="FF") {
				prefix="ff.";
				savedLabel.value="SAVED.  Please restart FireFox."
			} else if (anykeyPreferencesManager.hostAppId=="TB") {
				prefix="tb.";
				savedLabel.value="SAVED.  Please restart ThunderBird."
			}
			document.getElementById("toggleintexteditor-shortcut").value = prefs.getCharPref(prefix + "shortcuts.toggleintexteditor");
			document.getElementById("translit-shortcut").value = prefs.getCharPref(prefix + "shortcuts.translit");
			document.getElementById("keymapreference-shortcut").value = prefs.getCharPref(prefix + "shortcuts.keymapreference");
			document.getElementById("updateanykey-checkbox").checked = prefs.getBoolPref("version.autoupdate");
			document.getElementById("showstatusbaricon-checkbox").checked = prefs.getBoolPref("statusbar.showicon");

			var menuList=document.getElementById("keymaps-list");
			var keyMapArray =   anykeyPreferenceLoaderLib.loadKeyMapList();			
			var keyMapName=prefs.getCharPref("keyMapName");
			var helpPage= prefs.getCharPref(keyMapName+".helpPage");
			document.getElementById("helpUrl").href=helpPage;

			var selInd = 0;
			var count = 0;
			for (var i in keyMapArray) {
				if (keyMapArray[i] != null) {
					menuList.appendItem(keyMapArray[i],i,"");
					if (i==keyMapName) {
						selInd = count;
					}
				}
				count++;
			}
			menuList.selectedIndex = selInd;
			menuList.addEventListener("ValueChange",anykeyPreferencesManager.keyMapChanged, false)
			window.sizeToContent();
		} catch(e) {
			consoleDump(e.message);
		}
	},

	apply : function() {

		var prefix;
		if (anykeyPreferencesManager.hostAppId=="FF") {
			prefix="ff.";
		} else if (anykeyPreferencesManager.hostAppId=="TB") {
			prefix="tb.";
		}

		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("anykey.");

		if (document.getElementById("toggleintexteditor-shortcut").value != prefs.getCharPref(prefix + "shortcuts.toggleintexteditor"))
			prefs.setCharPref(prefix + "shortcuts.toggleintexteditor", document.getElementById("toggleintexteditor-shortcut").value);

		if (document.getElementById("translit-shortcut").value != prefs.getCharPref(prefix + "shortcuts.translit"))
			prefs.setCharPref(prefix + "shortcuts.translit", document.getElementById("translit-shortcut").value);

		if (document.getElementById("keymapreference-shortcut").value != prefs.getCharPref(prefix + "shortcuts.keymapreference"))
			prefs.setCharPref(prefix + "shortcuts.keymapreference", document.getElementById("keymapreference-shortcut").value);

		if (document.getElementById("updateanykey-checkbox").checked != prefs.getBoolPref("version.autoupdate"))
			prefs.setBoolPref("version.autoupdate", document.getElementById("updateanykey-checkbox").checked);

		if (document.getElementById("showstatusbaricon-checkbox").checked != prefs.getBoolPref("statusbar.showicon"))
			prefs.setBoolPref("statusbar.showicon", document.getElementById("showstatusbaricon-checkbox").checked);


        var btnApply = document.documentElement.getButton("extra1");
		btnApply.hidden=true;
		var btnCancel = document.documentElement.getButton("cancel");
		btnCancel.hidden=true;
		var savedLabel = document.getElementById("savedLabel");
		savedLabel.hidden=false;
		setTimeout("anykeyPreferencesManager.showGrid();", 1000);

		return true;
	},
	keyMapChanged :function(event){
		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("anykey.");
		prefs.setCharPref("keyMapName",event.target.selectedItem.value);
		var helpPage = prefs.getCharPref(event.target.selectedItem.value+".helpPage");
		document.getElementById("helpUrl").href=helpPage;
	},
	showGrid : function() {
		var savedLabel = document.getElementById("savedLabel");
		savedLabel.hidden=true;
		var btnApply = document.documentElement.getButton("extra1");
		btnApply.hidden=false;
		var btnCancel = document.documentElement.getButton("cancel");
		btnCancel.hidden=false;
	},
	close : function() {
		return true;
	},

	// recordShortCutKey by alex benenson
	recordShortCutKey : function(event) {
		event.preventDefault();		
		var mods = "";
		if (event.altKey) mods += (mods == "" ? "" : "+") + "Alt";
		if (event.ctrlKey) mods += (mods == "" ? "" : "+") + "Ctrl";
		if (event.shiftKey) mods += (mods == "" ? "" : "+") + "Shift";
		if (event.metaKey) mods += (mods == "" ? "" : "+") + "Meta";
		var keyCode = event.keyCode? event.keyCode : String.fromCharCode(event.charCode).toUpperCase().charCodeAt(0);
		var code = "";
		for (var i in event) {
			if (i.search(/DOM_VK_/i) == 0) 
				if (event[i] == keyCode) {
					code = i;
					break;
				}
		}
		code = code.replace(/DOM_/i, "");
		event.target.value = mods + (mods == "" ? "" : "+") + code;
	}
}